ExternalizeMethods (Groovy 5.1.0)

Package: groovy.transform

## [Java] Annotation Type ExternalizeMethods

- groovy.transform.ExternalizeMethods

-     @Documented
      @Retention(RetentionPolicy.SOURCE)
      @Target(ElementType.TYPE)
      @GroovyASTTransformationClass("org.codehaus.groovy.transform.ExternalizeMethodsASTTransformation")
      public @interface ExternalizeMethods

  Class annotation used to assist in the creation of `Externalizable` classes. The `@ExternalizeMethods` annotation instructs the compiler to execute an AST transformation which adds `writeExternal()` and `readExternal()` methods to a class and adds `Externalizable` to the interfaces which the class implements. The `writeExternal()` method writes each property (and optionally field) of the class while the `readExternal()` method will read each one back in the same order. Properties or fields marked as `transient` are ignored. This annotation is typically used in conjunction with the `@ExternalizeVerifier` annotation but most usually not directly but rather via `@AutoExternalizable` which is a shortcut for both annotations.

  Example usage:

       import groovy.transform.*
       @ExternalizeMethods
       class Person {
         String first, last
         List favItems
         Date since
       }

  Which will create a class of the following form:

       class Person implements Externalizable {
         ...
         public void writeExternal(ObjectOutput out) throws IOException {
           out.writeObject(first)
           out.writeObject(last)
           out.writeObject(favItems)
           out.writeObject(since)
         }

         public void readExternal(ObjectInput oin) {
           first = (String) oin.readObject()
           last = (String) oin.readObject()
           favItems = (List) oin.readObject()
           since = (Date) oin.readObject()
         }
         ...
       }

  Since:
    1.8.0

- - ### Element Summary

    Optional Element Summary
    Type | Name and Description
    --- | ---
    `String[]` | `excludes` Comma separated list of property names to exclude from externalizing.
    `boolean` | `includeFields` Include fields as well as properties when externalizing.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Element Detail

    - #### public String[] excludes

      Comma separated list of property names to exclude from externalizing. For convenience, a String with comma separated names can be used in addition to an array (using Groovy's literal list notation) of String values.

      Default:
        {}

    - #### public boolean includeFields

      Include fields as well as properties when externalizing.

      Default:
        false